These data are the raw LFP files used in "LSD alters brain stimulation in rodents"; N.B. all files and code are .mat and .m

Files in 'acute' are recordings with either LSD or SAL injections.
Files in '24 hours' are recordings 24 hours after LSD or SAL injections.

Files in 'base' are baseline recordings during IL (mPFC) stimulation.
Files in 'postLSD' are recordings during stimulation after LSD injections.

Code for analysis and visualization is in 'code/lsdPaperNotes.m'

Background: Psychedelics have resurged in neuroscience and psychiatry with promising success in psychedelic-assisted therapy for the treatment of anxiety, depression, and addiction. At the cellular level, psychedelics elicit neuroplastic processes 24 hours after administration, priming neural circuits for change. The acute effects of psychedelics are well characterized with functional imaging and neural oscillations showing an increase in the entropy of spontaneous cortical activity. 
Hypotheses: We hypothesized that cortical-striatal oscillations recorded in rats would confirm the effects of psychedelics. We also hypothesized that brain stimulation delivered 24 hours after LSD administration would lead to different effects than brain stimulation alone.
Methods: We recorded local field potential (LFP) oscillations from rats following lysergic acid diethylamide (LSD) or saline administration and determined if exposure to these treatments altered the effect of a targeted intervention (brain stimulation) 24 hours later.
Results: We confirmed acutely decreased low frequency power across the brain when rats are given LSD. We also demonstrated these altered states return to baseline after 24 hours. Brain stimulation applied in this window of heightened neuroplasticity produced distinct shifts in brain state compared to brain stimulation applied 24 hours after saline.
Conclusions: Despite the acute effects of LSD disappearing after 24 hours, there are still latent effects that synergize with brain stimulation to create different changes in brain activity compared to brain stimulation alone. Our  findings are the first to suggest that psychedelics could have a role clinically in combination with brain stimulation to achieve enhanced effects on brain activity and clinical outcomes.


